#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     clrDarkSlateGray
#property indicator_color2     clrDarkSlateGray
#property indicator_color3     clrDarkSlateGray
#property indicator_color4     clrBlue
#property indicator_color5     clrYellow
#property indicator_color6     clrWhite
#property indicator_width4     2
#property indicator_width5     2
#property indicator_width6     2
#property indicator_style1     STYLE_DASH
#property indicator_style2     STYLE_DASHDOTDOT
#property indicator_style3     STYLE_DASH
#property indicator_levelcolor clrDarkOrchid
#property indicator_levelstyle STYLE_SOLID

//
//
//
//
//

extern int            pq                       = 7;
extern int            pr                       = 7;
extern int            ps                       = 7;
extern int            trigger                  = 3;
extern double         Speed                    = 1.0;                    // Oma speed 
extern bool           Adaptive                 = false;                  // Should it be adaptive?
extern bool           ShowErgodicCCIMa         = false;
extern int            CCIMaPeriod              = 21;   
extern ENUM_MA_METHOD CCIMaMode                = MODE_SMA;  
extern int            VolatilityBandPeriod     = 34;
extern ENUM_MA_METHOD VolatilityBandMAMode     = MODE_SMA;
extern double         VolatilityBandMultiplier = 1.6185;

//
//
//
//
//

double bandUp[];
double bandMi[];
double bandDn[];
double ErgoCCI[];
double MainCCI[];
double ccima[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
  IndicatorBuffers(6);
    SetIndexBuffer(0,bandUp);
    SetIndexBuffer(1,bandMi);
    SetIndexBuffer(2,bandDn);
    SetIndexBuffer(3,ErgoCCI);   SetIndexLabel(3,"Egodic CCI");
    SetIndexBuffer(4,MainCCI);   SetIndexLabel(4,"Trigger Line");
    SetIndexBuffer(5,ccima);
    SetLevelValue(0,0);
    if (ShowErgodicCCIMa)
    {
      SetIndexStyle(5,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(5,DRAW_NONE);
   }       
   
      
    pq    = MathMax(pq,1);
    pr    = MathMax(pr,1);
    ps    = MathMax(ps,1);
    Speed = MathMax(Speed,-1.5);
    IndicatorShortName("Tdi Oma ergodic cci bands");
return(0);   
}
int deinit(){ return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double var1  = iAverage(iAverage(iAverage(        Close[i]-Close[i+1] ,pq,Speed,Adaptive,i,0),pr,Speed,Adaptive,i,1),ps,Speed,Adaptive,i,2);
      double var2  = iAverage(iAverage(iAverage(MathAbs(Close[i]-Close[i+1]),pq,Speed,Adaptive,i,3),pr,Speed,Adaptive,i,4),ps,Speed,Adaptive,i,5);
      if (var2 != 0)
            ErgoCCI[i] = 500.0 * var1/var2;
      else  ErgoCCI[i] = 0;
            MainCCI[i] = iAverage(ErgoCCI[i],trigger,Speed,Adaptive,i,6);      
    }
              
    for(i=limit; i>=0; i--)
    { 
              ccima[i]  = iMAOnArray(ErgoCCI,0,CCIMaPeriod,0,CCIMaMode,i);              
       double deviation = iStdDevOnArray(ErgoCCI,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
       double average   = iMAOnArray(ErgoCCI,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
              bandUp[i] = average+VolatilityBandMultiplier*deviation;
              bandDn[i] = average-VolatilityBandMultiplier*deviation;
              bandMi[i] = average;
    }
return(0);
}
         
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define omaInstances 7
double workOma[][omaInstances*7];
#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int i, int instanceNo=0)
{
   if (averagePeriod <=1) return(price); int r = Bars-i-1; instanceNo *= 7;
   if (ArrayRange(workOma,0)!=Bars) ArrayResize(workOma,Bars);
   
   double e1=workOma[(int)MathMax(r-1,0)][instanceNo+E1];  double e2=workOma[(int)MathMax(r-1,0)][instanceNo+E2];
   double e3=workOma[(int)MathMax(r-1,0)][instanceNo+E3];  double e4=workOma[(int)MathMax(r-1,0)][instanceNo+E4];
   double e5=workOma[(int)MathMax(r-1,0)][instanceNo+E5];  double e6=workOma[(int)MathMax(r-1,0)][instanceNo+E6];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[(int)MathMax(r-endPeriod,0)][instanceNo+res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod && r-k>=0; k++) noise=noise+MathAbs(price-workOma[r-k][instanceNo+res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   workOma[r][instanceNo+E1]  = e1;  workOma[r][instanceNo+E2] = e2;
   workOma[r][instanceNo+E3]  = e3;  workOma[r][instanceNo+E4] = e4;
   workOma[r][instanceNo+E5]  = e5;  workOma[r][instanceNo+E6] = e6;
   workOma[r][instanceNo+res] = price;
   return(v3);
}
